<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use League\OAuth2\Client\Provider\Google;

class SMTPToken extends CrudWithParameterBag {

    public function __construct(ParameterBag $parameterBag, $environment, Services\SMTPTokenService $SMTPTokenService) {
        $this->parameterBag                     = $parameterBag;
        $this->environment                      = $environment;
        $this->SMTPTokenService = $SMTPTokenService;

    }
    
    public function SaveToken(){
        if (!isset($_GET['code'])){
            return false;
        }
        
        $providerName = 'Google';
        
        $clientInfo = $this->SMTPTokenService->getSMTP();
        
        $clientId = isset($clientInfo[0]["DSCLIENTID"]) ? $clientInfo[0]["DSCLIENTID"] : null;
        $clientSecret = isset($clientInfo[0]["DSCLIENTSECRET"]) ? $clientInfo[0]["DSCLIENTSECRET"] : null;
        $uri = isset($clientInfo[0]["URI"]) ? $clientInfo[0]["URI"] : null;
        $redirectUri = isset($uri) ?  $uri.'backend/service/index.php/saveToken' : null;
        $params = [
            'clientId' => $clientId,
            'clientSecret' => $clientSecret,
            'redirectUri' => $redirectUri,
            'accessType' => 'offline'
        ];
        
        try{
            $provider = new Google($params);
            $token = $provider->getAccessToken(
                'authorization_code',
                [
                    'code' => $_GET['code']
                ]
            );
            $nome = 'testenome';
            $idade = 'testeidade';
            $code = htmlspecialchars($token->getRefreshToken(), );
            if ($code){
                $this->SMTPTokenService->saveToken($code);
                sleep(5);
                header("Location: ".$uri."mobile/#/man#params%2Fvnd10003_paramGerais");
                exit;
            }
            else{
                echo "<!DOCTYPE html>
                <html>
                    <style>
                        .tableLine {
                            background-color: #E6D7CF;
                        }
                        #tabela {
                            border-collapse: collapse;
                            border-spacing: 0;
                            width:100%;
                            height:100%;
                            margin:0px;
                            padding:0px;
                            text-align: center;
                        
                        }
                        #linhaTitulo {
                            height: 5px;
                            background-color: #b75826;
                        }
                        body{
                            background-color: #E6D7CF;
                            height: 100%;
                        }
                        
                        #token {
                            font-family: Cuprum, sans-serif;
                            padding-top: 2%;
                            width: auto;
                            height: auto;
                            background-color: #b7541f;
                            text-align: center;
                            color: white;
                            font-size: 20px;
                            padding-bottom: 2%;
                        }
                        </style>
                    <head>
                        <title>Erro token</title>
                    </head>
                    <body>
                    <table id='tabela'>
                        <div id='linhaTitulo'></div>
                        <tr class='tableLine'>
                            <td>
                                <div id='token'>
                                    <h1>Token já gerado anteriormente com essas credenciais!</h1>
                                    <p>Refaça as credenciais em: </p>
                                    <a href=https://console.cloud.google.com/apis/credentials>https://console.cloud.google.com/apis/credentials</a>
                                </div>
                                <br><img src='https://manage.teknisa.com/assets/images/logo/default.png?v' style='width: 250px;'>
                            </td>
                        </tr>
                    </table>
                    </body>
                </html>";
            }

        }
        catch (Exception $e){
            
        }
    }
    
    public function resetToken(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->SMTPTokenService->saveToken($row[0]);

    }
    
    public function getToken(DTO\Request\Row $request, DTO\Response $response){
        
        $row = $request->getRow();

        $providerName = 'Google';
        $clientId = isset($row['DSCLIENTID']) ? $row['DSCLIENTID'] : null;
        $clientSecret = isset($row['DSCLIENTSECRET']) ? $row['DSCLIENTSECRET'] : null;
        $uri = isset($row['URI']) ? $row['URI'] : null;
        
        $redirectUri = $uri . 'backend/service/index.php/saveToken';
        $tenantId = '';
        
        if (array_key_exists('provider', $_POST)) {
            $providerName = $_POST['provider'];
            $clientId = $_POST['clientId'];
            $clientSecret = $_POST['clientSecret'];
            $tenantId = $_POST['tenantId'];
            $_SESSION['provider'] = $providerName;
            $_SESSION['clientId'] = $clientId;
            $_SESSION['clientSecret'] = $clientSecret;
            $_SESSION['tenantId'] = $tenantId;
        } elseif (array_key_exists('provider', $_SESSION)) {
            $providerName = $_SESSION['provider'];
            $clientId = $_SESSION['clientId'];
            $clientSecret = $_SESSION['clientSecret'];
            $tenantId = $_SESSION['tenantId'];
        }

        $params = [
            'clientId' => $clientId,
            'clientSecret' => $clientSecret,
            'redirectUri' => $redirectUri,
            'accessType' => 'offline'
        ];

        $options = [];
        $provider = null;

        switch ($providerName) {
            case 'Google':
                $provider = new Google($params);
                $options = [
                    'scope' => [
                        'https://mail.google.com/'
                    ]
                ];
                break;
        }
        
        if (null === $provider) {
            exit('Provider missing');
        }
        
        if (!isset($_GET['code'])) {
            //If we don't have an authorization code then get one
            $authUrl = $provider->getAuthorizationUrl($options);
            $_SESSION['oauth2state'] = $provider->getState();
            $response->addDataset(new DataSet('getToken',array('url'=>$authUrl)));
            //Check given state against previously stored one to mitigate CSRF attack
        } elseif (empty($_GET['state']) || ($_GET['state'] !== $_SESSION['oauth2state'])) {
            unset($_SESSION['oauth2state']);
            unset($_SESSION['provider']);
            exit('Invalid state');
        }
    }
}